DEFINE Generate_plot_filename_postfix
  IF (Sys_plot_filename_generate)
    IF (LEN Sys_plot_format=1)
      LET Sys_plot_filename_postfix ('_'+Sys_plot_format)
    ELSE
      LET Sys_plot_filename_postfix Sys_plot_format
    END_IF
    LET Sys_plot_filename_postfix (Sys_plot_filename_postfix+'_'+
    Sys_plot_id_name+'_')
    LET T (ROUND TIME)
    LET Ts (STR (T DIV 3600))
    IF (LEN Ts=1)
      LET Sys_plot_filename_postfix (Sys_plot_filename_postfix+'0'+Ts)
    ELSE
      LET Sys_plot_filename_postfix (Sys_plot_filename_postfix+Ts)
    END_IF
    LET Ts (STR (T DIV 60 MOD 60))
    IF (LEN Ts=1)
      LET Sys_plot_filename_postfix (Sys_plot_filename_postfix+'0'+Ts)
    ELSE
      LET Sys_plot_filename_postfix (Sys_plot_filename_postfix+Ts)
    END_IF
    LET Ts (STR (T MOD 60))
    IF (LEN Ts=1)
      LET Sys_plot_filename_postfix (Sys_plot_filename_postfix+'0'+Ts)
    ELSE
      LET Sys_plot_filename_postfix (Sys_plot_filename_postfix+Ts)
    END_IF
    inq_env 22
    if (((inq 3)=2) OR ((inq 3)=3) OR ((inq 3)=4))
      LET Sys_plot_filename_postfix (Sys_plot_filename_postfix+'.hgl')
    else_if ((inq 3)=5)
      LET Sys_plot_filename_postfix (Sys_plot_filename_postfix+'.pdf')
    else_if ((inq 3)=6)
      LET Sys_plot_filename_postfix (Sys_plot_filename_postfix+'.ps')
    end_if
  ELSE
    LET Sys_plot_filename_postfix ''
  END_IF
END_DEFINE

DEFINE Create_printer_paper_names_ltab
LOCAL X {Anzahldrucker}
LOCAL Y
LOCAL Z {Druckerspalte}
LOCAL Z1 {Papierzeile}
LOCAL f {Druckername}
 INQ_ENV 22
 LET X (6+(INQ 2))
  CREATE_LTAB 64 X 'Printer_paper_names_ltab'
  LET Z 0
  LOOP
   LET Z (Z+1)
  EXIT_IF (Z>X)
   LET f (READ_LTAB 'Printer_names_ltab' Z 1)
   if (((SUBSTR f 1 1)=',') AND ((SUBSTR f (LEN f) 1)=','))
    let f (SUBSTR f 2 ((LEN f)-2))
   end_if
   Set_sys_plot_type f
   INQ_ENV 22
   let y (inq 902)
   let z1 1
   if (y<>'END-OF-LIST')
    WRITE_LTAB 'Printer_paper_names_ltab' Z1 Z y
    loop
     let z1 (z1+1)
     let y (inq 903)
    exit_if (y='END-OF-LIST')
     WRITE_LTAB 'Printer_paper_names_ltab' Z1 Z y
    end_loop
   end_if
  END_LOOP
END_DEFINE


DEFINE Refresh_printer_ltabs
  Create_printer_names_ltab 
  Create_printer_paper_names_ltab 
  LET Must_refresh_printer_ltabs 0
END_DEFINE

DEFINE Must_refresh_printer_ltabs
  1
END_DEFINE

DEFINE Create_printer_names_ltab
LOCAL X
LOCAL Z
 INQ_ENV 22
 LET X (6+(INQ 2))
  CREATE_LTAB X 1 'Printer_names_ltab'
  WRITE_LTAB 'Printer_names_ltab' 1 1 (INQ 900)
  LET Z 1
  LOOP
   LET Z (Z+1)
  EXIT_IF (Z>X)
   WRITE_LTAB 'Printer_names_ltab' Z 1 (INQ 901)
  END_LOOP
END_DEFINE


DEFINE Create_paper_names_dtab_layout
  TABLE_LAYOUT 'Paper_names_dtab' 'dummy'
  WHITE
  RGB_COLOR 0.573 0.573 0.667 ROWS 8 FRAME_WIDTH 1 HORIZONTAL
  WHITE
  SOLID VERTICAL
  WHITE
  SOLID SCROLL_BAR
  RGB_COLOR 0.83 0.83 0.83 (Font_width*2) TITLE_LAYOUT (Text_slot_height+1)
  '                   '
  END COLUMN_LAYOUT (Text_slot_height+1) '                   '
  END
  TABLE_TITLE 'Paper_names_dtab' Colo0 Bcol1 CENTER 'PAPER FORMAT' 1 1
  END
  END
  IF (Meprint_v_pelook=3)
    MOVE_TABLE 'Paper_names_dtab' 
    UPPER RIGHT 
    Graphic_area_up_right
    (PNT_XY (X_OF Graphic_area_up_right)
    (Y_OF Graphic_area_up_right - Menu_height + (Headline_height+1) +
    (15 * (Text_slot_height+1))))
    END
  ELSE
    MOVE_TABLE 'Paper_names_dtab' LOWER RIGHT (PNT_XY (X_OF
    Graphic_area_up_right) (Y_OF Graphic_area_low_left)) (PNT_XY (X_OF
    Graphic_area_up_right - (Font_width*13)) ((Y_OF Graphic_area_low_left)+((
    Text_slot_height+1)*18)+Rest_slot_height+1))
    END
  END_IF
END_DEFINE

DEFINE Update_curr_paper_names_ltab_mepr
  PARAMETER Printer_name_idx
  LOCAL Table_name
  LOCAL Num_rows
  LET Table_name 'Curr_paper_names_ltab_mepr'
  DELETE_LTAB_ROW Table_name ALL
  SELECT_FROM_LTAB 'Printer_paper_names_ltab' Printer_name_idx='*'
  END
  LET Num_rows (LTAB_ROWS 'sys_select')
  WHILE (Num_rows)
    WRITE_LTAB Table_name Num_rows 1 (READ_LTAB 'Printer_paper_names_ltab'
    Num_rows Printer_name_idx)
    LET Num_rows (Num_rows - 1)
  END_WHILE
  SORT_LTAB Table_name 1 CONFIRM
END_DEFINE

DEFINE Create_printer_names_dtab_layout
  TABLE_LAYOUT 'Printer_names_dtab'
  WHITE ROWS 8 FRAME_WIDTH 1 HORIZONTAL
  WHITE
  SOLID VERTICAL
  WHITE
  SOLID SCROLL_BAR
  RGB_COLOR 0.83 0.83 0.83 (Font_width*2) TITLE_LAYOUT (Text_slot_height+1)
  '                   '
  END COLUMN_LAYOUT (Text_slot_height+1) '                   '
  END
  TABLE_TITLE 'Printer_names_dtab' Colo0 Bcol1 CENTER 'PRINTER' 1 1
  END
  END
  IF (Meprint_v_pelook=3)
    MOVE_TABLE 'Printer_names_dtab' 
    UPPER RIGHT 
    Graphic_area_up_right
    (PNT_XY (X_OF Graphic_area_up_right)
    (Y_OF Graphic_area_up_right - Menu_height + (Headline_height+1) +
    (25 * (Text_slot_height+1))))
    END
  ELSE
    MOVE_TABLE 'Printer_names_dtab' LOWER RIGHT (PNT_XY (X_OF
    Graphic_area_up_right) (Y_OF Graphic_area_low_left)) (PNT_XY (X_OF
    Graphic_area_up_right - (Font_width*13)) ((Y_OF Graphic_area_low_left)+((
    Text_slot_height+1)*28)+Rest_slot_height+1))
    END
  END_IF
END_DEFINE

DEFINE Connect_tables_mepr
  CONNECT_TABLE 'Printer_names_dtab' 'Curr_printer_names_ltab_mepr'
  CONNECT_TABLE 'Paper_names_dtab' 'Curr_paper_names_ltab_mepr'
  TABLE_COLUMN 'Printer_names_dtab' COLUMN 1 LEFT
  WHITE
  RGB_COLOR 0.573 0.573 0.667 'Set_sys_plot_name_mepr "@v1"'
  END
  TABLE_COLUMN 'Paper_names_dtab' COLUMN 1 LEFT
  WHITE
  RGB_COLOR 0.573 0.573 0.667 'Set_sys_plot_size_mepr "@v1"'
  END
END_DEFINE

DEFINE Sm_plot_config_mepr_layout
  CURRENT_MENU 'Sm_plot_config_mepr'
  CURRENT_SCREEN 1
  MENU_LAYOUT Menu_position RIGHT Layout_body_plot_config_mepr
  Menu_home_point_top
  END
  MENU_STATUS ENABLE_INQ
  LET Sm_plot_config_mepr_layout_name 'Sm_plot_config_mepr'
END_DEFINE

DEFINE Initialize_mepr
  LOCAL Temp

  CREATE_LTAB 'Curr_printer_names_ltab_mepr'
  CREATE_LTAB 'Curr_paper_names_ltab_mepr'
  CREATE_LTAB 'Curr_printer_settings_ltab_mepr'
  TRAP_ERROR Init_conv_ltab_mepr
  LET Friendly_plot_name_mepr meprint_printer_save Redefine_table_position
  LET Must_refresh_printer_ltabs 1 Refresh_printer_ltabs_mepr 
  Set_sys_plot_size_mepr meprint_paper_save 
END_DEFINE

DEFINE Set_sys_plot_name_mepr
  PARAMETER Printer_name
  LOCAL Printer_name_idx
  LOCAL Printer_ltab
  LET Printer_ltab 'Curr_printer_names_ltab_mepr'
  SELECT_FROM_LTAB Printer_ltab 1=Printer_name
  END
  LET Printer_name_idx (READ_LTAB 'sys_select' 1 1)
  IF (Printer_name_idx='')
    DISPLAY 'Error: The specified printer cannot be found.'
    CANCEL
  END_IF
  LET Friendly_plot_name_mepr Printer_name
  if (((SUBSTR Printer_name 1 1)=',') AND ((SUBSTR Printer_name (LEN Printer_name) 1)=','))
   Set_sys_plot_type (SUBSTR Printer_name 2 ((LEN Printer_name)-2))
   Set_sys_plot_filename_prefix ''
   Set_sys_plot_filename_delold (FALSE)
   Set_sys_plot_filename_generate (TRUE)
  else
   if (Printer_name='MSWINDOW_EMF_CLIPBOARD')
    Set_sys_plot_type Printer_name
   else
    Set_sys_plot_type 'MSWINDOW_GDI_PRINTER'
   end_if
   PLOTTER_TYPE Printer_name
   Set_sys_plot_filename_prefix ''
   Set_sys_plot_filename_delold (TRUE)
   Set_sys_plot_filename_generate (FALSE)
  end_if
  LET Sys_plot_name (READ_LTAB 'Printer_names_ltab' Printer_name_idx 1)

  HIGHLIGHT_LTAB Printer_ltab COLUMN 1 OFF
  HIGHLIGHT_LTAB Printer_ltab Printer_name_idx 1 ON
  Update_curr_paper_names_ltab_mepr Printer_name_idx
  Set_sys_plot_size_mepr '' 
  inq_env 22 Highlight_selected_paper_mepr (inq 301)
  Update_printer_orientation_mepr
END_DEFINE

DEFINE Set_default_paper_ltab_mepr
  PARAMETER Printer_name
  PARAMETER Paper_name
  LOCAL Curr_printer_set_ltab_name
  LOCAL Idx
  LOCAL Num_rows
  LET Curr_printer_set_ltab_name 'Curr_printer_settings_ltab_mepr'
  SELECT_FROM_LTAB Curr_printer_set_ltab_name 1=Printer_name
  END
  LET Idx (READ_LTAB 'sys_select' 1 1)
  IF (Idx='')
    LET Num_rows (LTAB_ROWS Curr_printer_set_ltab_name)
    WRITE_LTAB Curr_printer_set_ltab_name (Num_rows+1) 1 Printer_name
    WRITE_LTAB Curr_printer_set_ltab_name (Num_rows+1) 2 Paper_name
  ELSE
    WRITE_LTAB Curr_printer_set_ltab_name Idx 1 Printer_name
    WRITE_LTAB Curr_printer_set_ltab_name Idx 2 Paper_name
  END_IF
END_DEFINE

DEFINE Menu_tables_update
  PARAMETER T_from
  PARAMETER T_to
  PARAMETER T_show
  System_tables_update T_from T_to T_show Mepr_table_update T_from T_to
  T_show User_table_update
END_DEFINE

DEFINE Update_printer_orientation_mepr
  INQ_MENU CURRENT
  IF ((INQ 301)<>'Sm_plot_config_mepr')
    CURRENT_MENU 'Sm_plot_config_mepr'
  END_IF
  IF (Sys_plot_type='MSWINDOW_GDI_PRINTER')
   MENU Colo0 Bcol1 (DGETTEXT 'me10wuires' 'Orientation') '' 23 1
   inq_env 22
   IF ((inq 4)=0)
     MENU Colo1 Bcol4 (DGETTEXT 'me10wuires' 'Portrait') 'WIN_PRT_MGR ORIENTATION LANDSCAPE END Update_printer_orientation_mepr' 23 2
   ELSE
     MENU Colo1 Bcol4 (DGETTEXT 'me10wuires' 'Landscape') 'WIN_PRT_MGR ORIENTATION PORTRAIT END Update_printer_orientation_mepr' 23 2
   END_IF
  ELSE
     MENU Colo0 Bcol0 (DGETTEXT 'me10mac' '') '' 23 1
     MENU Colo0 Bcol0 (DGETTEXT 'me10mac' '') '' 23 2
  END_IF
END_DEFINE

DEFINE Highlight_selected_paper_mepr
  PARAMETER Paper_name
  LOCAL Paper_ltab
  LET Paper_ltab 'Curr_paper_names_ltab_mepr'
  SELECT_FROM_LTAB Paper_ltab 1=Paper_name
  END
  HIGHLIGHT_LTAB Paper_ltab COLUMN 1 OFF
  HIGHLIGHT_LTAB Paper_ltab (READ_LTAB 'sys_select' 1 1) 1 ON
END_DEFINE

DEFINE Set_sys_plot_size_mepr
  PARAMETER Paper_name
  LOCAL Idx
  LOCAL Printer_idx
  LOCAL Scroll_idx
  LOCAL User_def_str
  LOCAL Paper_ltab
  LET Paper_ltab 'Curr_paper_names_ltab_mepr'
  IF (Paper_name='')
    SELECT_FROM_LTAB 'Curr_printer_settings_ltab_mepr' 1=
    Friendly_plot_name_mepr
    END
    LET Idx (READ_LTAB 'sys_select' 1 1)
    IF (Idx='')
      LET Paper_name (READ_LTAB Paper_ltab 1 1)
      IF (Paper_name='')
        CANCEL
      END_IF
    ELSE
      LET Paper_name (READ_LTAB 'Curr_printer_settings_ltab_mepr' Idx 2)
      SELECT_FROM_LTAB Paper_ltab 1=Paper_name
      END
      IF ((READ_LTAB 'sys_select' 1 1)='')
        LET Paper_name (READ_LTAB Paper_ltab 1 1)
      END_IF
      Scroll_selected_paper_mepr Paper_name
    END_IF
  END_IF
  Highlight_selected_paper_mepr Paper_name
  SELECT_FROM_LTAB Paper_ltab 1=Paper_name
  END Set_default_paper_ltab_mepr Friendly_plot_name_mepr Paper_name
  SELECT_FROM_LTAB 'Curr_printer_names_ltab_mepr' 1=Friendly_plot_name_mepr
  END
  LET Printer_idx (READ_LTAB 'sys_select' 1 1)
  CREATE_LTAB 'Temp_ltab_mepr'
  SELECT_FROM_LTAB 'Printer_paper_names_ltab' Printer_idx='*'
  'Temp_ltab_mepr'
  END
  SELECT_FROM_LTAB 'Temp_ltab_mepr' Printer_idx=Paper_name
  END
  LET Idx (READ_LTAB 'sys_select' 1 1)
  DELETE_LTAB 'Temp_ltab_mepr'
  IF (Idx='')
    DISPLAY 'Error: The specified paper format cannot be found.'
    CANCEL
  END_IF
  Set_sys_plot_format Paper_name
  Plot_define_format_viewport
  IF (Sys_plot_type='MSWINDOW_GDI_PRINTER')
   win_prt_mgr paper Paper_name end
  END_IF
END_DEFINE

DEFINE Sm_plot_config_mepr
  LET Lastmen 'Tm_plot_config_mepr'
  IF (I_port)
    Check_i_port
  END_IF
  IF (NOT I_port)
    MENU_BUFFER ON
    CURRENT_MENU Sm_plot_config_mepr_layout_name T_clear_menu
    Menu_tables_control_icons
    MENU Colo0 Bcol5 CENTER (DGETTEXT 'me10mac' 'PLOT CONFIG') '' 1 3
    SHOW_TABLE ON 'Printer_names_dtab'
    SHOW_TABLE ON 'Paper_names_dtab'
    MENU Colo0 Bcol1 CENTER 'UPDATE' 'LET Must_refresh_printer_ltabs 1 Refresh_printer_ltabs_mepr' 21 1
    Update_printer_orientation_mepr
    MENU Colo0 Bcol5 CENTER 'MEN 1' 'sm_plot' 25 1
  END_IF
  TABLE_TITLE 'Printer_names_dtab' Colo0 Bcol1 CENTER 'DRUCKER' 1 1
  END
  TABLE_TITLE 'Paper_names_dtab' Colo0 Bcol1 CENTER 'PAPIERFORMAT' 1 1
  END
END_DEFINE

DEFINE Sm_plot_config_mepr_layout_name
  Sm_plot_config_mepr_layout
END_DEFINE

DEFINE Conv_printer_paper_names_ltab
  LOCAL Table_name
  LOCAL Num_cols
  LOCAL Num_rows
  LOCAL Paper_name
  LET Table_name 'Printer_paper_names_ltab'
  LET Num_cols (LTAB_COLUMNS Table_name)
  WHILE (Num_cols)
    LET Num_rows (LTAB_ROWS Table_name)
    WHILE (Num_rows)
      LET Paper_name (READ_LTAB Table_name Num_rows Num_cols)
      Convert_table_string_mepr Table_name Num_rows Num_cols Paper_name
      LET Num_rows (Num_rows - 1)
    END_WHILE
    LET Num_cols (Num_cols - 1)
  END_WHILE
END_DEFINE

DEFINE Tm_plot_config_mepr
  Sm_plot_config_mepr
END_DEFINE

DEFINE Refresh_printer_ltabs_mepr
  IF (Must_refresh_printer_ltabs)
    Refresh_printer_ltabs
    DELETE_LTAB_ROW 'Curr_paper_names_ltab_mepr' ALL
    Update_curr_printer_names_ltab_mepr Conv_printer_paper_names_ltab
    Connect_tables_mepr
    SELECT_FROM_LTAB 'Curr_printer_names_ltab_mepr' 1=
    Friendly_plot_name_mepr
    END
    IF ((READ_LTAB 'sys_select' 1 1)<>'')
      Set_sys_plot_name_mepr Friendly_plot_name_mepr
    ELSE
      IF ((READ_LTAB 'Curr_printer_names_ltab_mepr' 1 1)<>'')
        Set_sys_plot_name_mepr (READ_LTAB 'Curr_printer_names_ltab_mepr' 1 1
        )
      END_IF
    END_IF
  END_IF
END_DEFINE

DEFINE Init_conv_ltab_mepr
  LOCAL Num_rows
  CREATE_LTAB 'Conv_ltab_mepr'
  WRITE_LTAB 'Conv_ltab_mepr' 1 1 (CHR 220)
  WRITE_LTAB 'Conv_ltab_mepr' 1 2 (CHR 219)
  WRITE_LTAB 'Conv_ltab_mepr' 2 1 (CHR 196)
  WRITE_LTAB 'Conv_ltab_mepr' 2 2 (CHR 216)
  WRITE_LTAB 'Conv_ltab_mepr' 3 1 (CHR 214)
  WRITE_LTAB 'Conv_ltab_mepr' 3 2 (CHR 218)
  WRITE_LTAB 'Conv_ltab_mepr' 4 1 (CHR 252)
  WRITE_LTAB 'Conv_ltab_mepr' 4 2 (CHR 207)
  WRITE_LTAB 'Conv_ltab_mepr' 5 1 (CHR 228)
  WRITE_LTAB 'Conv_ltab_mepr' 5 2 (CHR 204)
  WRITE_LTAB 'Conv_ltab_mepr' 6 1 (CHR 246)
  WRITE_LTAB 'Conv_ltab_mepr' 6 2 (CHR 206)
  WRITE_LTAB 'Conv_ltab_mepr' 7 1 (CHR 223)
  WRITE_LTAB 'Conv_ltab_mepr' 7 2 (CHR 222)
  LET Num_rows (LTAB_ROWS 'Conv_ltab_mepr')
  WRITE_LTAB 'Conv_ltab_mepr' (Num_rows+1) 1 '['
  WRITE_LTAB 'Conv_ltab_mepr' (Num_rows+1) 2 '('
  WRITE_LTAB 'Conv_ltab_mepr' (Num_rows+2) 1 ']'
  WRITE_LTAB 'Conv_ltab_mepr' (Num_rows+2) 2 ')'
END_DEFINE

DEFINE Layout_body_plot_config_mepr
  Headline_height ' | |               | ' Text_slot_height ''
  Text_slot_height '' Text_slot_height '' Text_slot_height ''
  Text_slot_height '' Text_slot_height '' Text_slot_height ''
  Text_slot_height '' Text_slot_height '' Text_slot_height
  '                     ' Text_slot_height '' Text_slot_height ''
  Text_slot_height '' Text_slot_height '' Text_slot_height ''
  Text_slot_height '' Text_slot_height '' Text_slot_height ''
  Text_slot_height '' Text_slot_height '                     '
  Text_slot_height '                     ' Text_slot_height
  '          |          ' Text_slot_height '                     '
  Text_slot_height '          |          ' Bottom_slot_height
  '    |     |     |    ' Bottom_slot_height '    |     |     |    '
END_DEFINE


DEFINE Mepr_table_update
  PARAMETER T_from
  PARAMETER T_to
  PARAMETER T_show
  LOCAL Current_menu_name
  INQ_MENU CURRENT
  LET Current_menu_name (INQ 301)
  IF (Current_menu_name='Sm_plot_config_mepr')
    Menu_table_update 'Printer_names_dtab' T_from T_to T_show
    Menu_table_update 'Paper_names_dtab' T_from T_to T_show
  END_IF
END_DEFINE

DEFINE Scroll_selected_paper_mepr
  PARAMETER Paper_name
  LOCAL Num_rows
  LOCAL Paper_ltab
  LET Paper_ltab 'Curr_paper_names_ltab_mepr'
  SELECT_FROM_LTAB Paper_ltab 1=Paper_name
  END
  LET Scroll_idx (READ_LTAB 'sys_select' 1 1)
  LET Num_rows (LTAB_ROWS Paper_ltab)
  IF ((Scroll_idx<=7) AND (Num_rows<=7))
    SCROLL_LTAB Paper_ltab 1
  ELSE_IF (Scroll_idx>=(Num_rows - 7))
    LET Scroll_idx (Num_rows - 7)
    SCROLL_LTAB Paper_ltab Scroll_idx
  ELSE
    SCROLL_LTAB Paper_ltab Scroll_idx
  END_IF
END_DEFINE

DEFINE Redefine_table_position
  LOCAL Tablet_connected
  INQ_ENV 10
  LET Tablet_connected (INQ 3)
  IF (Tablet_connected)
   IF (Meprint_v_pelook=3)
    MOVE_TABLE 'Paper_names_dtab' 
    UPPER RIGHT 
    Graphic_area_up_right
    (PNT_XY (X_OF Graphic_area_up_right)
    (Y_OF Graphic_area_up_right - Menu_height + (Headline_height+1) +
    (15 * (Text_slot_height+1))))
    END
    MOVE_TABLE 'Printer_names_dtab' 
    UPPER RIGHT 
    Graphic_area_up_right
    (PNT_XY (X_OF Graphic_area_up_right)
    (Y_OF Graphic_area_up_right - Menu_height + (Headline_height+1) +
    (25 * (Text_slot_height+1))))
    END
   ELSE
    MOVE_TABLE 'Printer_names_dtab' LOWER RIGHT (PNT_XY (X_OF
    Graphic_area_up_right) (Y_OF Graphic_area_low_left)) (PNT_XY (X_OF
    Graphic_area_up_right - (Font_width*0)) ((Y_OF Graphic_area_low_left)+(
    (Text_slot_height+1)*17)+Rest_slot_height+1))
    END
    MOVE_TABLE 'Paper_names_dtab' LOWER RIGHT (PNT_XY (X_OF
    Graphic_area_up_right) (Y_OF Graphic_area_low_left)) (PNT_XY (X_OF
    Graphic_area_up_right - (Font_width*0)) ((Y_OF Graphic_area_low_left)+(
    (Text_slot_height+1)*7)+Rest_slot_height+1))
    END
   END_IF
  END_IF
END_DEFINE

DEFINE Convert_table_string_mepr
  PARAMETER Table_name
  PARAMETER Table_row
  PARAMETER Table_col
  PARAMETER Conv_string
  LOCAL Num_conv_rows
  LOCAL Str_pos
  LOCAL From_string
  LOCAL To_string
  LOCAL Temp_str
  LET Num_conv_rows (LTAB_ROWS 'Conv_ltab_mepr')
  WHILE (Num_conv_rows)
    LET From_string (READ_LTAB 'Conv_ltab_mepr' Num_conv_rows 1)
    LET To_string (READ_LTAB 'Conv_ltab_mepr' Num_conv_rows 2)
    LET Temp_str (Conv_string)
    LET Conv_string ''
    LOOP
      LET Str_pos (POS Temp_str From_string)
    EXIT_IF (Str_pos=0)
      LET Conv_string (Conv_string+(SUBSTR Temp_str 1 (Str_pos - 1))+
      To_string)
      LET Temp_str (SUBSTR Temp_str (Str_pos+(LEN From_string)) ((LEN
      Temp_str) - Str_pos))
    END_LOOP
    LET Conv_string (Conv_string+Temp_str)
    LET Num_conv_rows (Num_conv_rows - 1)
  END_WHILE
  WRITE_LTAB Table_name Table_row Table_col Conv_string
END_DEFINE

DEFINE Sm_plot
  LET Lastmen 'Tm_plot'
  IF (I_port)
    Check_i_port
  END_IF
  IF (NOT I_port)
    INQ_ENV 4
    LET Sys_plot_plotscale (INQ 2)
    LET Sys_plot_plotscale_auto_on_off (INQ 17)
    LET Sys_plot_center (INQ 601)
    INQ_ENV 22
    LET Sys_plot_plotter_mepr (inq 3)
    MENU_BUFFER ON
    CURRENT_MENU Sm_plot_layout_name T_clear_menu Menu_tables_control_icons
    MENU Colo0 Bcol5 CENTER (DGETTEXT 'me10mac' 'PLOT') '' 1 3
    MENU Colo0 Bcol1 (DGETTEXT 'me10mac' 'POSITION')
    'Set_sys_plot_center ON Sm_plot_pp_update' 2 1
    MENU Menu_slot_highlight (ON=Sys_plot_center) (DGETTEXT 'me10mac'
    'Center') 'Set_sys_plot_center ON Sm_plot_pp_update' 2 2
    MENU Menu_slot_highlight (OFF=Sys_plot_center) (DGETTEXT 'me10mac'
    'Left') 'Set_sys_plot_center OFF Sm_plot_pp_update' 3 2
    MENU Colo0 Bcol1 (DGETTEXT 'me10mac' 'SCALE')
    'Plot_enter_plotscale_and_update' 4 1
    MENU Menu_slot_highlight (Sys_plot_plotscale_auto_on_off=0) (
    Sys_plot_plotscale_value_string) 'Plot_enter_plotscale_and_update' 4 2
    MENU Menu_slot_highlight (Sys_plot_plotscale_auto_on_off=1) (DGETTEXT
    'me10mac' 'Fit') 'PLOT_SCALE AUTO END Sm_plot_pp_update' 5 2
    MENU Colo0 Bcol1 (DGETTEXT 'me10mac' 'OUTPUT')
    'Set_sys_plot_source ALL Sm_plot_pp_update' 6 1
    MENU Menu_slot_highlight (ALL=Sys_plot_source) (DGETTEXT 'me10mac' 'All'
    ) 'Set_sys_plot_source ALL Sm_plot_pp_update' 6 2
    MENU Menu_slot_highlight (TWO_PTS=Sys_plot_source) (DGETTEXT 'me10mac'
    'Box') 'Plot_enter_two_pts_and_update' 7 1
    MENU Menu_slot_highlight (CURRENT_WINDOW=Sys_plot_source) (DGETTEXT
    'me10mac' 'Viewport')
    'Set_sys_plot_source CURRENT_WINDOW Sm_plot_pp_update' 7 2
    MENU Colo0 Bcol1 (DGETTEXT 'me10mac' 'IMAGE COL') 8 1
    Sm_update_plot_color
    MENU Colo0 Bcol1 (DGETTEXT 'me10mac' 'CONTENTS')
    'Set_sys_plot_as_displayed 0 Sm_plot_pp_update' 9 1
    MENU Menu_slot_highlight (0=Sys_plot_as_displayed) (DGETTEXT 'me10mac'
    'Drawing') 'Set_sys_plot_as_displayed 0 Sm_plot_pp_update' 9 2
    MENU Menu_slot_highlight (Sys_plot_as_displayed) (DGETTEXT 'me10mac'
    'Curr Show') 'Set_sys_plot_as_displayed 1 Sm_plot_pp_update' 10 2
    MENU Colo0 Bcol1 (DGETTEXT 'me10mac' 'ROTATE ANG')
    'Plot_enter_rotate_and_update' 11 1
    MENU Menu_slot_highlight (TRUE) Sys_plot_rotate_value_string
    'Plot_enter_rotate_and_update' 11 2
    MENU Colo0 Bcol1 (DGETTEXT 'me10mac' 'LTYPE LEN') 'PLOT_LINETYPE_LENGTH'
    12 1
    MENU Colo0 Bcol1 (DGETTEXT 'me10mac' 'ON ERROR')
    'Sm_plot_configuration_On_error' 14 1
    Sm_plot_configuration_on_error_slot
    MENU Colo0 Bcol1 (DGETTEXT 'me10mac' 'PLOT OPTN')
    'Change_plot_color_option_mode' 15 1
    MENU Colo1 Bcol4 'Mujo&Haso' 'Change_plot_color_option_mode' 15 2
    END Set_sys_plot_color_mode_name 15 2
    MENU Colo0 Bcol1 (DGETTEXT 'me10mac' 'B/W IMAGE') 16 1
    Sm_update_plot_reverse_video
    MENU Colo0 Bcol1 (DGETTEXT 'me10mac' 'IMAGE QA') 17 1 
    Sm_update_plot_res

    IF (Sys_plot_type='MSWINDOW_GDI_PRINTER')
      MENU Colo0 Bcol1 (DGETTEXT 'me10mac' 'GDI SETUP')
      'WIN_PRINT_SETUP PP_WIN_UPDATE' 23 1
      MENU Colo0 Bcol1 (DGETTEXT 'me10mac' 'PRINT MGR') '' 22 1
      Sm_update_print_mgr_dialog
    ELSE_IF (Sys_plot_type='MSWINDOW_EMF_CLIPBOARD')
      MENU Colo0 Bcol0 (DGETTEXT 'me10mac' '') '' 22 2
      MENU Colo0 Bcol0 (DGETTEXT 'me10mac' '') '' 23 1
      MENU Colo0 Bcol1 (DGETTEXT 'me10mac' 'CLPBD SIZE')
      'Plot_enter_user_clipboard_format_and_update Sm_update_plot_color' 22 1
    ELSE
      MENU Colo0 Bcol0 (DGETTEXT 'me10mac' '') '' 22 1
      MENU Colo0 Bcol0 (DGETTEXT 'me10mac' '') '' 22 2
      MENU Colo0 Bcol0 (DGETTEXT 'me10mac' '') '' 23 1
    END_IF
    MENU Colo0 Bcol1 (DGETTEXT 'me10mac' 'ALL SHEETS') 19 1
    Sm_update_print_sheets
    MENU Colo0 Bcol2 (DGETTEXT 'me10mac' 'START PLOT') 'Plot_plot Sm_plot'
    21 1
    INQ_ENV 22
    MENU Menu_slot_highlight (TRUE) (INQ 302) 'Plot_plot Sm_plot' 21 2 
    Sm_update_print_preview_show
    Sm_update_print_preview_type
    MENU Colo0 Bcol5 CENTER (DGETTEXT 'me10mac' '') '' 25 1
    MENU Colo0 Bcol5 CENTER (DGETTEXT 'me10mac' 'CONFIG')
    'Sm_plot_config_mepr Refresh_printer_ltabs_mepr' 25 2
    Eight_menu_slots_add
  END_IF
END_DEFINE

DEFINE Change_plot_color_option_mode
  LOCAL Ncurrsel
  IF ((Sys_plot_color_option>=0) AND (Sys_plot_color_option<3))
    LET Sys_plot_color_option (Sys_plot_color_option+1)
  ELSE
    LET Sys_plot_color_option 0
  END_IF
  LET Ncurrsel Sys_plot_color_option Set_sys_plot_color_option Ncurrsel
  PP_WIN_UPDATE Sm_plot
END_DEFINE

DEFINE Sm_update_plot_res
  MENU Colo1 Bcol4 (DGETTEXT 'me10mac' 'BEST PIX')
  'PLOT_PIX_RES 0 Sm_update_plot_res' 17 2
  MENU Colo1 Bcol4
  IF (Curr_plot_pix_res_option=0)
    (DGETTEXT 'me10mac' 'LOW PIX') 'PLOT_PIX_RES 1 Sm_update_plot_res'
  ELSE
    (DGETTEXT 'me10mac' 'BEST PIX') 'PLOT_PIX_RES 0 Sm_update_plot_res'
  END_IF
  17 2
END_DEFINE

DEFINE Sm_update_plot_reverse_video
  MENU Colo1 Bcol4 (DGETTEXT 'me10mac' 'NORMAL')
  'Plot_pix_reverse_video 1 Sm_update_plot_reverse_video PP_WIN_UPDATE' 16 2
  MENU Colo1 Bcol4
  IF (Curr_plot_pix_reverse_video_option=0)
    (DGETTEXT 'me10mac' 'NORMAL')
    'Plot_pix_reverse_video 1 Sm_update_plot_reverse_video PP_WIN_UPDATE'
  ELSE
    (DGETTEXT 'me10mac' 'REVERSE')
    'Plot_pix_reverse_video 0 Sm_update_plot_reverse_video PP_WIN_UPDATE'
  END_IF
  16 2
END_DEFINE

DEFINE Sm_plot_configuration_on_error_slot
  MENU Menu_slot_highlight TRUE
  IF (Sys_plot_stop_on_error)
    (DGETTEXT 'me10mac' 'STOP')
  ELSE
    (DGETTEXT 'me10mac' 'CONT')
  END_IF
  'Sm_plot_configuration_On_error' 14 2
END_DEFINE

DEFINE Update_curr_printer_names_ltab_mepr
  LOCAL Table_name
  LOCAL Num_rows
  LOCAL Printer_name
  LOCAL Hostname
  LOCAL Str_pos
  LET Table_name 'Curr_printer_names_ltab_mepr'
  DELETE_LTAB_ROW Table_name ALL
  LET Num_rows (LTAB_ROWS 'Printer_names_ltab')
  WHILE (Num_rows)
    LET Printer_name (READ_LTAB 'Printer_names_ltab' Num_rows 1)
    LET Str_pos (POS Printer_name '\')
    IF (Str_pos)
      LET Hostname (SUBSTR Printer_name 3 ((LEN Printer_name) - 2))
      LET Str_pos (POS Hostname '\')
      LET Hostname (SUBSTR Hostname 1 (Str_pos - 1))
      LET Printer_name (SUBSTR Printer_name (Str_pos+3) (LEN Printer_name))
      LET Printer_name (Printer_name+' on '+Hostname)
    END_IF
    Convert_table_string_mepr Table_name Num_rows 1 Printer_name
    LET Num_rows (Num_rows - 1)
  END_WHILE
END_DEFINE

DEFINE Meprint_pelook
  INQ_ENV 0
  IF (INQ 2>= 13.0)
    INQ_ENV 10
    LET Meprint_v_pelook (INQ 6)
  ELSE
    beep display '**** Wrong Drafting Revision ****' cancel
  END_IF
END_DEFINE

define meprint_save_env
inq_env 22
let meprint_printer_save (inq 302)
let meprint_paper_save (inq 301)
end_define

meprint_save_env
Meprint_pelook
Create_printer_names_dtab_layout
Create_paper_names_dtab_layout

Initialize_mepr